Package org.eclipse.m2m.atl.emftvm.impl

## Class RuleImpl.DistinctState

- java.lang.Object
- - org.eclipse.m2m.atl.emftvm.impl.RuleImpl.DistinctState

Direct Known Subclasses:
  `RuleImpl.IsDistinctState`, `RuleImpl.IsNotDistinctState`

Enclosing class:
  RuleImpl

    protected abstract class RuleImpl.DistinctState
    extends java.lang.Object

Base class for code that depends on the rule's `Rule.isDistinctElements()` state.

### Constructor Summary

Constructors
`protected` `DistinctState()`

### Method Summary

All Methods Instance Methods Abstract Methods
`abstract boolean` `checkDistinct​(java.lang.Object[] values, int index, java.lang.Object value)` Checks if

### Methods inherited from class java.lang.Object

`clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

### Constructor Detail

#### DistinctState

    protected DistinctState()

### Method Detail

#### checkDistinct

    public abstract boolean checkDistinct​(java.lang.Object[] values,
                                          int index,
                                          java.lang.Object value)

Checks if

    values

are distict, if so required by the rule.

Parameters:
  `values` - the currently collected values
  `index` - the index up to which to check the `values`
  `value` - the value to check against `values`
Returns:
  `true` iff `value` is ok